package main

import (
	"fmt"
	"html/template"
	"os"
)

func main() {
	//tplText := `hello golang {{ . }`// 错误演示
	tplText := `hello golang {{ . }}`
	tpl := template.Must(template.New("tpl").Parse(tplText)) // 直接输出错误
	tpl.Execute(os.Stdout, `html/template`)
	fmt.Println()

	// slice
	tplText = `hello golang {{ index . 0 }}`
	tpl = template.Must(template.New("tpl").Parse(tplText))
	tpl.Execute(os.Stdout, []string{"html/template", "golang"})
	fmt.Println()

	// map
	tplText = `hello golang {{ .htmltemplate }} {{ .key1 }}`
	tpl = template.Must(template.New("tpl").Parse(tplText))
	tpl.Execute(os.Stdout, map[string]string{"htmltemplate": "html/template", "key1": "val1"})
	fmt.Println()

	// struct
	tplText = `hello golang {{ .Name }} {{ .Age }}`
	tpl = template.Must(template.New("tpl").Parse(tplText))
	tpl.Execute(os.Stdout, struct {
		Name string
		Age  int
	}{
		Name: "xianbin",
		Age:  18,
	})
}
